//FFName=Bildausschnitt
//FFSubmenu=Tools
//FFSkriptAuthor=Michael Sonntag (ms@editorei.de)
//FFSkriptVersion=1.4
//FFSkriptModified=2011-09-12
//FFSkriptURL=http://fixfoto-tipps.de/bildausschnitt

/*
Schneidet aus allen markierten Bilder aus der Computer-Ansicht einen whlbaren Ausschnitt aus.
Dabei kann festgelegt werden, welchen Abstand der Ausschnitt zum Rand hat. Wahlweise kann der Ausschnitt
horizontal und/oder vertikal zentriert werden. In diesem Fall werden die Abstandswerte ignoriert.

Der Beschnittrahmen kann wahlweise fr jedes einzelne Bild gewhlt werden. Das erste Bild bernimmt die
eingestellten Werte und gibt die Werte des verschobenen Rahmen an das nchste Bild weiter.

Die Bilder werden im Unterverzeichnis "ausschnitt" gespeichert. Alternativ knnen auch die Originale 
berschrieben werden. Diese Einstellung wird im Gegensatz zu allen anderen nicht gespeichert und muss
jedesmal erneut gewhlt werden. 
*/

main();

function main()
{
var fso, sel, i, sp, image, len, idx, w, h, dlgname;
var ext;
dlgname = "Bildausschnitt";

// Versionscheck
var vc = versionCheck("3.3","10",dlgname);
if(vc==false) return;

// Mindestens 1 Bilder markiert?
if (FF_GetImageCount() < 1) 
	{
	FF_MessageBox("Bitte mindestens ein Bild markieren!", 64);
	return;
	}

var currVersion = eval(FF_GetMajor() + "." + FF_GetMinor());
var currBuild = FF_GetBuild;

//** Start Dialog Bildausschnitt **
FF_AddDialog("Bildausschnitt",255,125);
FF_AddControl("Bildausschnitt","Verschiedenes","GROUP",5,41,244,61);
FF_AddControl("Bildausschnitt","Gres des Ausschnittes","GROUP",170,3,79,34);
FF_AddControl("Bildausschnitt","Abstand des Ausschnittes vom Rand","GROUP",5,3,161,34);
FF_AddControl("Bildausschnitt","Los gehts","BUTTON",213,107,36,13);
FF_AddControl("Bildausschnitt","Von links:","STATIC",12,10,46,11);
FF_AddControl("Bildausschnitt","Von oben:","STATIC",12,22,46,11);
FF_AddControl("Bildausschnitt","Breite:","STATIC",177,10,57,11);
FF_AddControl("Bildausschnitt","Hhe:","STATIC",177,22,57,11);
FF_AddControl("Bildausschnitt","x","SLEDIT",44,11,33,10);
FF_AddControl("Bildausschnitt","y","SLEDIT",44,23,33,10);
FF_AddControl("Bildausschnitt","w","SLEDIT",209,11,33,10);
FF_AddControl("Bildausschnitt","h","SLEDIT",209,23,33,10);
FF_AddControl("Bildausschnitt","Version 1.4","STATIC",82,111,41,11);
FF_AddControl("Bildausschnitt","hcenter","BOOL",100,12,8,8);
FF_AddControl("Bildausschnitt","Horizontal zentrieren","STATIC",109,10,53,11);
FF_AddControl("Bildausschnitt","vcenter","BOOL",100,24,8,8);
FF_AddControl("Bildausschnitt","Vertikal zentrieren","STATIC",109,22,53,11);
FF_AddControl("Bildausschnitt","oder","STATIC",83,16,16,11);
FF_AddControl("Bildausschnitt","Format:","STATIC",12,63,29,11);
FF_AddControl("Bildausschnitt","iformat","COMBO",44,64,33,10);
FF_AddControl("Bildausschnitt","Abbrechen","BUTTON",5,107,33,13);
FF_AddControl("Bildausschnitt","Homepage","BUTTON",44,107,33,13);
FF_AddControl("Bildausschnitt","crop","BOOL",12,78,8,8);
FF_AddControl("Bildausschnitt","Bildausschnitt pro Bild manuell whlen (nimmt obige Werte als Vorgaben fr das erste Bild)","STATIC",22,76,217,11);
FF_AddControl("Bildausschnitt","Dateiformat fr die Zielbilder im Unterverzeichnis \"ausschnitt\"","STATIC",83,63,153,11);
FF_AddControl("Bildausschnitt","overwrite","BOOL",12,89,8,8);
FF_AddControl("Bildausschnitt","Original berschreiben","STATIC",22,87,55,11);
FF_AddControl("Bildausschnitt","Markierung:","STATIC",12,50,29,11);
FF_AddControl("Bildausschnitt","c_markierung","COMBO",44,50,57,10);
//** End Dialog Bildausschnitt **

x = FF_GetProfile(dlgname, "x"); if(x == "") x = 0; FF_SetControl(dlgname, "x", x);
y = FF_GetProfile(dlgname, "y"); if(y == "") y = 0; FF_SetControl(dlgname, "y", y);
w = FF_GetProfile(dlgname, "w"); if(w == "") w = 0; FF_SetControl(dlgname, "w", w);
h = FF_GetProfile(dlgname, "h"); if(h == "") h = 0; FF_SetControl(dlgname, "h", h);
vcenter = FF_GetProfile(dlgname, "vcenter"); if(vcenter == "") vcenter = 0; FF_SetControl(dlgname, "vcenter", vcenter);
hcenter = FF_GetProfile(dlgname, "hcenter"); if(hcenter == "") hcenter = 0; FF_SetControl(dlgname, "hcenter", hcenter);

// Bildformate
iformats = FF_GetProfile(dlgname,"iformat");
modes = new Array(
	"JPG", 
	"PNG", 
	"TIF", 
	"BMP"
	);
for(i=0; i<modes.length; i++) FF_SetControl(dlgname,"iformat",modes[i]);
if((iformats == "") || (iformats =="1,#QNAN")) FF_SetControl(dlgname, "iformat", "TIF"); else FF_SetControl(dlgname,"iformat",iformats);

// Markierungen
mark = FF_GetProfile(dlgname,"c_markierung");
markmodes = new Array(
	"Keine Markierung",
	"Goldener Schnitt", 
	"Drittelteilung", 
	"Fadenkreuz"
	);
for(i=0; i<markmodes.length; i++) FF_SetControl(dlgname,"c_markierung",markmodes[i]);
if((mark == "") || (mark =="1,#QNAN")) FF_SetControl(dlgname, "c_markierung", "Keine Markierung"); else FF_SetControl(dlgname,"c_markierung",mark);

// Beschneiden
crop = FF_GetProfile(dlgname, "crop");
if(crop == "") crop = 0; FF_SetControl(dlgname, "crop", crop);

// Dialogschleife, die unbegrenzt oft durchlaufen wird
for(;;)
{

// Zeige Den Dialog an
var window = FF_ShowDialog(dlgname);

// Frage die Buttons im Dialog ab (alle auer ggf. Abbrechen  oder CANCEL (Kreuz oben rechts)
switch(window)
	{
		case "Los gehts":
		var x = parseFloat(FF_GetControl(dlgname, "x"));
		var y = parseFloat(FF_GetControl(dlgname, "y"));
		var w = parseFloat(FF_GetControl(dlgname, "w"));
		var h = parseFloat(FF_GetControl(dlgname, "h"));
		var vcenter = parseFloat(FF_GetControl(dlgname, "vcenter"));
		var hcenter = parseFloat(FF_GetControl(dlgname, "hcenter"));
		var iformats = FF_GetControl(dlgname, "iformat");
		var mark = FF_GetControl(dlgname, "c_markierung");
		var crop = FF_GetControl(dlgname, "crop");
		var overwrite = FF_GetControl(dlgname, "overwrite");
	
		// Zielbildformat
		switch (iformats)
		{
			case "JPG": ext = ".jpg"; break;
			case "PNG": ext = ".png"; break;
			case "TIF": ext = ".tif"; break;
			case "BMP": ext = ".bmp"; break;
		}

		// markierungen
		switch (mark)
		{
			case "Keine Markierung": 	mflag = 0; break;
			case "Goldener Schnitt":	mflag = 1; break;
			case "Drittelteilung": 		mflag = 6; break;
			case "Fadenkreuz": 				mflag = 9; break;
			default: 									mflag = 0; break;
		}
		
		// Ungltige Werte abfangen
		if((w == 0) || (h == 0)) 
			{
			FF_MessageBox("Bitte eine gltige Hhe und/oder Breite des Ausschnitts angegeben!",16);
			break;
			}

		FF_WriteProfile(dlgname, "x", x);
		FF_WriteProfile(dlgname, "y", y);
		FF_WriteProfile(dlgname, "w", w);
		FF_WriteProfile(dlgname, "h", h);
		FF_WriteProfile(dlgname, "vcenter", vcenter);
		FF_WriteProfile(dlgname, "hcenter", hcenter);
		FF_WriteProfile(dlgname, "iformat", iformats);
		FF_WriteProfile(dlgname, "c_markierung", mark);
		FF_WriteProfile(dlgname, "crop", crop);

		// Bildausschnitt vor dem ersten Bild zurcksetzen
		FF_WriteProfile(dlgname, "x1", "");
		FF_WriteProfile(dlgname, "y1", "");
		FF_WriteProfile(dlgname, "w1", "");
		FF_WriteProfile(dlgname, "h1", "");

		// Beschneiderahmen anzeigen oder nicht?
		if(crop == 1)	
			{
			Cropper(dlgname,x,y,w,h,vcenter,hcenter,ext,1,mflag,overwrite);
			}
				else
					{
					Cropper(dlgname,x,y,w,h,vcenter,hcenter,ext,0,mflag,overwrite);
					}

		window = "CANCEL";
		break;

		case "Homepage":
		var shell = new ActiveXObject("WScript.Shell");
		shell.Run("http://fixfoto-tipps.de/bildausschnitt",0,false);
		window = "CANCEL";
		break;

		case "Abbrechen":
		window = "CANCEL";
		break;
	}
if(window == "CANCEL") break;
}
FF_CloseDialog(dlgname);
}


function Cropper(dlgname, x, y, w, h, vc, hc, iformat, crop, mflag, overwrite)
{
/* Parameter: 
dlgname = Dialogname
x = Abstand von links
y = Abstand von oben
w = Breite des Ausschnitts
h = Hhe des Ausschnitts
vc = Vertikale Zentrierung
hc = Horizontale Zentrierung
iformat = Bildformat (jpg, png, tif,bmp)
crop = Bildausschnitt von Hand einstellen (0 = nein, 1 = ja)
mflag = Markierung
overwrite = Original berschreiben (0 = nein, 1 = ja)
*/

fso = new ActiveXObject("Scripting.FileSystemObject");
deletelog = 1;
sel = FF_GetSelection("1").split("\r\n");

for (i = 0; i < sel.length; i++)
	{
	sp = SplitPath(sel[i]);
	image = sp.dir + sp.file + sp.ext;
	if(overwrite == 0) 
		{
		cropdir = "ausschnitt\\"; 
		}
		else
			{
			cropdir = "";
			iformat = sp.ext;
			}

	// Verzeichnisse und Dateinamen
	nImage = sp.dir + cropdir + sp.file + iformat;
	nFolder = sp.dir + cropdir;	
	len = sel.length;
	idx = i;
	idxplus = i+1;
	var logfile = nFolder + "\\log.txt";
	if(!fso.FolderExists(nFolder)) fso.CreateFolder(nFolder);

	// Logfile zu Beginn lschen
	if(deletelog == 1)
		{
		if(fso.FileExists(logfile)) fso.DeleteFile(logfile);
		deletelog = 0;
		}
	FF_LoadImage(image);
	oWidth = FF_GetImageFileWidth(image);
	oHeight = FF_GetImageFileHeight(image);

	xw = x+w;	
	yh = y+h;
	
	// Zentrierung
	if(vc == 1) y = (oHeight-h)/2;
	if(hc ==1) x = (oWidth-w)/2;

	//FF_MessageBox("Zielformat: " + iformat + "\n\nOriginalbreite: " + oWidth + "\nOriginalhhe: " + oHeight + "\n\nxw: " + xw + "\nyh: " + yh + "\n\nAbstand von links: " + x + "\nAbstand von oben: " + y + "\n\nBreite: " + w + "\nHhe: " + h + "\n\nnFolder: " + nFolder + "\nOriginaldatei: " + image + 	"\nZieldatei: " + nImage, 64);

	// Bilder berspringen, die zu klein sind und diese Bilder in die Logdatei schreiben
	if((oWidth < xw) || (oHeight < yh)) 
		{
		//FF_MessageBox("Bild: " + sp.file + sp.ext + " ist zu gro und wird bersprungen",64);
		if(!fso.FileExists(logfile)) 
			{
			fso.CreateTextFile(logfile, true);	
			header = 1;
			}
		var f = fso.GetFile(logfile);
		var ts = f.OpenAsTextStream(8);
		if(header==1)
			{
			ts.WriteLine("Logdatei des Skripts \"Bildausschnitt\":\n");
			ts.WriteLine("Diese Bilder wurden nicht verarbeitet, da sie fr den Bildausschnitt zu klein sind:\n");
			header = 0;
			}
		ts.WriteLine(image);
		ts.Close();
		continue;
		}

	// Beschnittrahmen manuell whlen
	if(crop == 1)
		{
		// Hole Werte des letzten Bildes aus der Registry
		x1 = FF_GetProfile(dlgname, "x1"); if(x1 == "") x1 = x; 
		y1 = FF_GetProfile(dlgname, "y1"); if(y1 == "") y1 = y; 
		w1 = FF_GetProfile(dlgname, "w1"); if(w1 == "") w1 = w; 
		h1 = FF_GetProfile(dlgname, "h1"); if(h1 == "") h1 = h; 

		// Bildausschnitt bestimmen (mit Abbruchmimik)
		cancel = FF_GetRectangle(x1, y1, w1, h1,1,mflag);
		if (!cancel) return;

		//FF_GetRectangle(x1, y1, w1, h1,1);
		params = FF_GetParam().split("\n");
		x = parseInt(params[0]);
		y = parseInt(params[1]);
		w = parseInt(params[2]);
		h = parseInt(params[3]);
		
		// Schreibe Werte fr das nchste Bild in die Registry		
		FF_WriteProfile(dlgname, "x1", x);
		FF_WriteProfile(dlgname, "y1", y);
		FF_WriteProfile(dlgname, "w1", w);
		FF_WriteProfile(dlgname, "h1", h);

		}

	// Beschnitt
	FF_Crop(x,y,w,h);
	FF_SaveImage(nImage, 0);
	FF_SetProgressText((idx*100)/len, 100, "Verarbeite Bild " + idxplus + " von " + len)
	}
	FF_UpdateDir();
	FF_SetImagePath(nFolder)
	if(fso.FileExists(logfile))	
		{
		var shell = new ActiveXObject("WScript.Shell");
		shell.Run(logfile,10,true);
		}
}

// liefert Verzeichnis mit abschlieendem Backslash,
// Dateinamen und Erweiterung mit einleitendem Punkt
function SplitPath(path)
	{
	var fso = new ActiveXObject("Scripting.FileSystemObject");
	var	result = new Object();
	result.dir = fso.GetParentFolderName(path) + "\\";
	result.file = fso.GetBaseName(path);
	result.ext = "." + fso.GetExtensionName(path);
	return result;
	}

// Versionscheck
function versionCheck(version, build, scriptname)
{
var currVersion = eval(FF_GetMajor() + "." + FF_GetMinor());
var currBuild = FF_GetBuild;
 
if ((currVersion < version) || (currVersion == version) && (currBuild < build))
	{
	message = "Sie verwenden FixFoto " + currVersion + " B: " + currBuild;
	message += "\nFr dieses Skript ist FixFoto " + version + " B: " + build + " notwendig";
	message += "\n\nMchten Sie die aktuelle Betaversion laden?";
	loadbeta = FF_MessageBox(message,52);
	if (loadbeta == 6)
		{
		var shell = new ActiveXObject("WScript.Shell");
		shell.Run("http://www.ffsf.de/local_links.php?catid=6",0,false);		
		return false;
		}
		else
			{
			return false;
			}
	}
}

